<template>
  <div class="audit-paper-unsubmit">
    <el-form class="part-filter-form" :model="filter" inline>
      <el-form-item label="提交人">
        <el-input
          v-model="filter.creator"
          placeholder="请输入提交人姓名"
        ></el-input>
      </el-form-item>
      <el-form-item label="试卷名称">
        <el-input
          v-model="filter.paperName"
          placeholder="请输入试卷名称"
        ></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="danger" @click="toPage(1)">查询</el-button>
      </el-form-item>
    </el-form>

    <div>
      <el-table
        v-loading="loading"
        element-loading-text="拼命加载中"
        :data="dataList"
      >
        <el-table-column label="试卷名称" prop="paperName"> </el-table-column>
        <el-table-column label="课程" prop="courseName"> </el-table-column>
        <el-table-column label="提交时间" prop="creationTime" width="153">
        </el-table-column>
        <el-table-column label="操作" width="170" fixed="right">
          <template slot-scope="scope">
            <div class="operate_left">
              <el-button
                size="mini"
                type="primary"
                plain
                @click="toEdit(scope.row)"
                >编辑</el-button
              >
              <el-button
                size="mini"
                type="primary"
                plain
                @click="toSubmit(scope.row)"
                >提交</el-button
              >
            </div>
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          :current-page="currentPage"
          :page-size="pageSize"
          :page-sizes="[10, 20, 50, 100, 200, 300]"
          layout="total, sizes, prev, pager, next, jumper"
          :total="total"
          @current-change="toPage"
          @size-change="handleSizeChange"
        >
        </el-pagination>
      </div>
    </div>
  </div>
</template>

<script>
import { auditPaperUnsubmitPageListApi, submitPaperApi } from "../api";

export default {
  name: "AuditPaperUnsubmit",
  data() {
    return {
      filter: { creator: "", paperName: "" },
      dataList: [],
      currentPage: 1,
      pageSize: 10,
      total: 0,
      loading: false,
    };
  },
  mounted() {
    this.toPage(1);
  },
  methods: {
    toPage(page) {
      this.currentPage = page;
      this.getList();
    },
    async getList() {
      this.loading = true;
      const res = await auditPaperUnsubmitPageListApi({
        ...this.filter,
        curPage: this.currentPage,
        pageSize: this.pageSize,
      }).catch(() => {});
      this.loading = false;
      if (!res) return;
      this.dataList = res.data.content;
      this.total = res.data.totalElements;
    },
    handleSizeChange(val) {
      this.pageSize = val;
      this.toPage(1);
    },
    toEdit(row) {
      window.open(
        this.getRouterPath({
          name: "EditPaper",
          params: {
            id: row.id,
            parentView: "audit-paper",
          },
        })
      );
    },
    async toSubmit(row) {
      const confirm = await this.$confirm(`确定要提交该试卷吗?`, "提示", {
        type: "warning",
      }).catch(() => {});
      if (confirm !== "confirm") return;

      await submitPaperApi([row.id]);
      this.$message.success("操作成功！");
    },
  },
};
</script>
